/*	Filename:Archiver.cpp						*/
/************************************************/
/*												*/
/*					TArchiver					*/
/*												*/
/*			A[JCo[R|[lg			*/
/*												*/
/*					Ver.1.52					*/
/*												*/
/*		Copyright(C) 2002-2003 by DELTA SOFT	*/
/*												*/
/************************************************/
/*
A[JCo[
http://www.csdinc.co.jp/archiver/
*/
/*----------------------------------------------*/
/*						`						*/
/*----------------------------------------------*/

#include "Archiver.h"
#include "DSDEF.h"
#pragma hdrstop

#pragma package(smart_init)

namespace ArchiverN
{
char	*ArchiveTypeStr[]=
{
	"","LHA","ZIP","CAB","TAR","RAR","ARJ","BGA","GCA","YZ1","7ZIP","JACK","BELL","ISH",NULL
};
}

char	*ArchiverErrorMsg[]=
{
	"",
	"",
	"",
	"",
	"",
	"ERROR DISK SPACE",
	"ERROR READ ONLY",
	"ERROR USER SKIP",
	"ERROR UNKNOWN TYPE",
	"ERROR METHOD",
	"ERROR PASSWORD FILE",
	"ERROR VERSION",
	"ERROR FILE CRC",
	"ERROR FILE OPEN",
	"ERROR MORE FRESH",
	"ERROR NOT EXIST",
	"ERROR ALREADY EXIST",
	"ERROR TOO MANY FILES",
	"ERROR MAKEDIRECTORY",
	"ERROR CANNOT WRITE",
	"ERROR HUFFMAN CODE",
	"ERROR COMMENT HEADER",
	"ERROR HEADER CRC",
	"ERROR HEADER BROKEN",
	"ERROR ARC FILE OPEN",
	"ERROR NOT ARC FILE",
	"ERROR CANNOT READ",
	"ERROR FILE STYLE",
	"ERROR COMMAND NAME",
	"ERROR MORE HEAP MEMORY",
	"ERROR ENOUGH MEMORY",
	"ERROR ALREADY RUNNING",
	"ERROR USER CANCEL",
	"ERROR HARC ISNOT OPENED",
	"ERROR NOT SEARCH MODE",
	"ERROR NOT SUPPORT",
	"ERROR TIME STAMP",
	"ERROR TMP OPEN",
	"ERROR LONG FILE NAME",
	"ERROR ARC READ ONLY",
	"ERROR SAME NAME FILE",
	"ERROR NOT FIND ARC FILE",
	"ERROR RESPONSE READ",
	"ERROR NOT FILENAME",
	"ERROR TMP COPY",
	"ERROR EOF",
	"ERROR ADD TO LARC",
	"ERROR TMP BACK SPACE",
	"ERROR SHARING",
	"ERROR NOT FIND FILE",
	"ERROR LOG FILE",
	"ERROR NO DEVICE",
	"ERROR GET ATTRIBUTES",
	"ERROR SET ATTRIBUTES",
	"ERROR GET INFORMATION",
	"ERROR GET POINT",
	"ERROR SET POINT",
	"ERROR CONVERT TIME",
	"ERROR GET TIME",
	"ERROR SET TIME",
	"ERROR CLOSE FILE",
	"ERROR HEAP MEMORY",
	"ERROR HANDLE",
	"ERROR TIME STAMP RANGE",
	"ERROR MAKE ARCHIVE",
	"ERROR NOT CONFIRM NAME",
	"ERROR UNEXPECTED EOF",
	"ERROR INVALID END MARK",
	"ERROR INVOLVED LZH",
	"ERROR NO END MARK",
	"ERROR HDR INVALID SIZE",
	"ERROR UNKNOWN LEVEL",
	"ERROR BROKEN DATA"
};

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	A[JCo[G[bZ[W\	*****/

void __fastcall	ArchiverErrorDlg(AnsiString S,int err)
{
		err &=0x7FFF;
		S+="\r\n";
		if (err>ERROR_ARCMSG_END)
		then	S+="Archiver Error";
		else	S+=ArchiverErrorMsg[err];

		MessageDlg(S,mtError,TMsgDlgButtons()<<mbOK,0);
}

/*****	R[obN֐	*****/
/*
BOOL	CALLBACK	ArchiverCallBack(HWND hwnd,UINT Msg,UINT State,VOID *Info)
{
	TArchiver	*Archiver=(TArchiver*)hwnd;

	if (Archiver)
	then	return(Archiver->CallBack(Msg,State,Info));

	return(TRUE);
}
*/
/*----------------------------------------------*/
/*			TArchiveOptionsNX				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TArchiveOptions::TArchiveOptions(void)
{
	FExclusive=new TStringList();
	Init();
}

/*****	fXgN^	*****/

__fastcall	TArchiveOptions::~TArchiveOptions(void)
{
	if (FExclusive)
	then	delete	FExclusive;
}

/*****		****/

void __fastcall	TArchiveOptions::Init(void)
{
	FSystemFile=true;
	FDialog=false;
	FIgnoreDir=false;
	FWorkDir="";
	FMethod="";
	FUpdate=true;
	FOverwrite=true;
	FRecursive=true;
	FStartDate="";
	FEndDate="";
	FExclusive->Clear();
}

/*****	OXg̐ݒ	*****/

void __fastcall	TArchiveOptions::SetExclusive(TStringList* List)
{
	FExclusive->Assign(List);
}

/*----------------------------------------------*/
/*			TCustomArchiverNX			  	*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TCustomArchiver::TCustomArchiver(TComponent *Owner)
:TComponent(Owner)
{
	FArchiver=(TArchiver*)Owner;

	if (FArchiver)
	then	FParentWindow=FArchiver->ParentWindow;

	FType=atUnknown;
	FOutBuffSize=32768;
}

/*****	fXgN^	*****/

__fastcall	TCustomArchiver::~TCustomArchiver(void)
{
	if (FhArc)
	then	Close();

	if (FHandle)
	then	FreeLibrary(FHandle);
}

/*****	vV[W[AhX̎擾	*****/

FARPROC __fastcall	TCustomArchiver::GetProcAddress(AnsiString Name)
{
	return(::GetProcAddress(FHandle,Name.c_str()));
}

/*****	DLL̃[h	*****/

void __fastcall	TCustomArchiver::Load(AnsiString FileName,AnsiString Head)
{
	AnsiString	S;

	FHandle=::LoadLibrary(FileName.c_str());
	if (FHandle==NULL)
	then return;

	S=Head+"GetVersion";
	ArcGetVersion=(TArcGetVersion)GetProcAddress(S.c_str());
	S=Head+"CheckArchive";
	ArcCheckArchive=(TArcCheckArchive)GetProcAddress(S.c_str());
	S=Head+"GetRunning";
	ArcGetRunning=(TArcGetRunning)GetProcAddress(S.c_str());
	S=Head;
	ArcCommand=(TArcCommand)GetProcAddress(S.c_str());
	S=Head+"QueryFunctionList";
	ArcQueryFunctionList=(TArcQueryFunctionList)GetProcAddress(S.c_str());
	S=Head+"GetBackGroundMode";
	ArcGetBackGroundMode=(TArcGetBackGroundMode)GetProcAddress(S.c_str());
	S=Head+"SetBackGroundMode";
	ArcSetBackGroundMode=(TArcSetBackGroundMode)GetProcAddress(S.c_str());
	S=Head+"GetCursorMode";
	ArcGetCursorMode=(TArcGetCursorMode)GetProcAddress(S.c_str());
	S=Head+"SetCursorMode";
	ArcSetCursorMode=(TArcSetCursorMode)GetProcAddress(S.c_str());
	S=Head+"GetCursorInterval";
	ArcGetCursorInterval=(TArcGetCursorInterval)GetProcAddress(S.c_str());
	S=Head+"SetCursorInterval";
	ArcSetCursorInterval=(TArcSetCursorInterval)GetProcAddress(S.c_str());
	S=Head+"GetFileCount";
	ArcGetFileCount=(TArcGetFileCount)GetProcAddress(S.c_str());
	S=Head+"ExtractMem";
	ArcExtractMem=(TArcExtractMem)GetProcAddress(S.c_str());
	S=Head+"CompressMem";
	ArcCompressMem=(TArcCompressMem)GetProcAddress(S.c_str());
	S=Head+"ConfigDialog";
	ArcConfigDialog=(TArcConfigDialog)GetProcAddress(S.c_str());
	S=Head+"OpenArchive";
	ArcOpenArchive=(TArcOpenArchive)GetProcAddress(S.c_str());
	S=Head+"CloseArchive";
	ArcCloseArchive=(TArcCloseArchive)GetProcAddress(S.c_str());
	S=Head+"FindFirst";
	ArcFindFirst=(TArcFindFirst)GetProcAddress(S.c_str());
	S=Head+"FindNext";
	ArcFindNext=(TArcFindNext)GetProcAddress(S.c_str());
	S=Head+"SetOwnerWindowEx";
	ArcSetOwnerWindowEx=(TArcSetOwnerWindowEx)GetProcAddress(S.c_str());

	if (ArcSetOwnerWindowEx)
	then	ArcSetOwnerWindowEx(FArchiver->Handle,NULL/*ArchiverCallBack*/);

	if (ArcSetCursorMode)
	then ArcSetCursorMode(false);
}

/*****	s	*****/

int __fastcall	TCustomArchiver::Command(AnsiString Cmd)
{
	Close();

	if (ArcCommand==NULL)
	then	return(-1);

	char	*bf=new char[FOutBuffSize];
	int	res=ArcCommand(FParentWindow,Cmd.c_str(),bf,FOutBuffSize);
	FOutput=bf;
	delete	bf;

	return(res);
}

/*****	Č	*****/

void __fastcall	TCustomArchiver::Research(AnsiString Filter)
{
	Close();
	FFindFirst=0;
	if (FFileName.IsEmpty())
	then {
		FFindFirst=-1;
		return;
	}
	Open(FFileName,FMode);

	if (FindFirst(Filter))
	then	FFindFirst=1;
	else	FFindFirst=-1;
}

/*****		*****/

bool __fastcall	TCustomArchiver::Find(void)
{
	if (FFindFirst)
	then {
		if (FFindFirst==-1)
		then {
			FFindFirst=0;
			return(false);
		}
		FFindFirst=0;
		return(true);
	}

	return(FindNext());
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TCustomArchiver::MakeOptions(void)
{
	return("");
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TCustomArchiver::MakePackCommand(AnsiString Path)
{
	AnsiString	S;

	S="a ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TCustomArchiver::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	S="e ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	return(S);
}

/*****	k	*****/

int __fastcall	TCustomArchiver::Pack(AnsiString Path)
{
	return(Command(MakePackCommand(Path)));
}

/*****		*****/

int __fastcall	TCustomArchiver::Unpack(AnsiString Path)
{
	return(Command(MakeUnpackCommand(Path)));
}

/*****	̈k	*****/

int __fastcall	TCustomArchiver::Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr)
{
	AnsiString	S=MakePackCommand(Path);
	return(CompressMemory(S,bf,Size,Time,Attr));
}

/*****	։	*****/

int __fastcall	TCustomArchiver::Unpack(AnsiString Path,void *bf,DWORD &Size,time_t *Time,WORD *Attr)
{
	AnsiString	S=MakeUnpackCommand(Path);
	return(ExtractMemory(S,bf,Size,Time,Attr));
}

/*****	ɂ̐̌	*****/

int __fastcall	TCustomArchiver::Check(AnsiString Path)
{
	return(0);
}

/*****	API gp\ǂ擾	*****/

bool __fastcall	TCustomArchiver::QueryFunction(int Function)
{
	if (ArcQueryFunctionList)
	then	return(ArcQueryFunctionList(Function));
	else	return(false);
}

/*****	o[W̎擾	*****/

WORD __fastcall	TCustomArchiver::GetVersion(void)
{
	if (ArcGetVersion)
	then	return(ArcGetVersion());
	else	return(0);
}

/*****	Ƀt@C	*****/

bool __fastcall	TCustomArchiver::IsArchive(AnsiString FileName,DWORD Mode)
{
	Close();

	if (ArcCheckArchive)
	then	return(ArcCheckArchive(FileName.c_str(),Mode));
	else	return(false);
}

/*****	A[JCo[쒆	*****/

bool __fastcall	TCustomArchiver::GetRunning(void)
{
	if (ArcGetRunning)
	then	return(ArcGetRunning());
	else	return(false);
}


/*****	ftHgݒ肷	*****/

bool __fastcall	TCustomArchiver::ConfigDialog(int Mode,AnsiString &Option)
{
	bool		res=false;

	if (ArcConfigDialog)
	then {
		int	sz=Option.Length();
		if (sz<520)
		then	sz=520;
		char    	*bf=new char[sz];
		bf[0]=0;
		strcpy(bf,Option.c_str());

		if (ArcConfigDialog(FParentWindow,bf,Mode)==TRUE)
		then	res=true;
		Option=bf;
		delete	bf;
	}

	return(res);
}

/*****	obNOh[h	*****/

bool __fastcall	TCustomArchiver::GetBackGroundMode(void)
{
	if (ArcGetBackGroundMode)
	then	return(ArcGetBackGroundMode());
	else	return(false);
}

/*****	obNOh[hݒ肷	*****/

bool __fastcall	TCustomArchiver::SetBackGroundMode(bool Mode)
{
	if (ArcSetBackGroundMode)
	then	return(ArcSetBackGroundMode(Mode));
	else	return(false);
}

/*****	J[\\[h擾	*****/

bool __fastcall	TCustomArchiver::GetCursorMode(void)
{
	if (ArcGetCursorMode)
	then	return(ArcGetCursorMode());
	else	return(false);
}

/*****	J[\\[hݒ肷	*****/

bool __fastcall	TCustomArchiver::SetCursorMode(bool Mode)
{
	if (ArcSetCursorMode)
	then	return(ArcSetCursorMode(Mode));
	else	return(false);
}

/*****	J[\̉]x擾	*****/

WORD __fastcall	TCustomArchiver::GetCursorInterval(void)
{
	if (ArcGetCursorInterval)
	then	return(ArcGetCursorInterval());
	else	return(0);
}

/*****	J[\̉]xݒ肷	*****/

bool __fastcall	TCustomArchiver::SetCursorInterval(WORD Interval)
{
	if (ArcSetCursorInterval)
	then	return(ArcSetCursorInterval(Interval));
	else	return(false);
}

/*****	i[t@C擾	*****/

int __fastcall	TCustomArchiver::GetCount(void)
{
	if (ArcGetFileCount)
	then	return(ArcGetFileCount(FFileName.c_str()));
	else	return(0);
}

/*****	obt@֓WJ	*****/

int __fastcall	TCustomArchiver::ExtractMemory(AnsiString Command,void *bf,DWORD &Size,time_t *Time,WORD *Attr)
{
	DWORD	BFSize=Size;

	Close();

	if (ArcExtractMem)
	then {
		Size=0;
		return(ArcExtractMem(FParentWindow,Command.c_str(),(BYTE*)bf,BFSize,Time,Attr,&Size));
	}
	return(-1);
}

/*****	obt@̓ekďɂɊi[	*****/

int __fastcall	TCustomArchiver::CompressMemory(AnsiString Command,void *bf,DWORD &Size,time_t Time,WORD Attr)
{
	DWORD	BFSize=Size;
	time_t	*Timep=&Time;

	Close();

	if (ArcCompressMem)
	then {
		Size=0;
		if (Time==0)
		then	Timep=NULL;
		return(ArcCompressMem(FParentWindow,Command.c_str(),(BYTE*)bf,BFSize,Timep,&Attr,&Size));
	}
	else	return(-1);
}

/*****	t@C̐ݒ	*****/

void __fastcall	TCustomArchiver::SetFileName(AnsiString Path)
{
	if (FhArc)
	then	Close();
	FFileName=Path;
}

/*****	Ƀt@C̃I[v	*****/

bool __fastcall	TCustomArchiver::Open(AnsiString FileName,DWORD Mode)
{
	SetFileName(FileName);
	FMode=Mode;

	if (ArcOpenArchive)
	then {
		FhArc=ArcOpenArchive(FParentWindow,FFileName.c_str(),FMode);
		if (FhArc)
		then	return(true);
	}
	return(false);
}

/*****	Ƀt@C̃N[Y	*****/

void __fastcall	TCustomArchiver::Close(void)
{
	if ((ArcCloseArchive) AND (FhArc))
	then {
		ArcCloseArchive(FhArc);
		FhArc=0;
	}
}

/*****	ŏ̊i[t@C̏擾	*****/

bool __fastcall	TCustomArchiver::FindFirst(AnsiString Filter)
{
	ZeroMemory(&FFileInfo,sizeof(FFileInfo));

	if ((ArcFindFirst) AND (FhArc))
	then {
		if (ArcFindFirst(FhArc,Filter.c_str(),&FFileInfo)==0)
		then	return(true);
	}
	return(false);
}

/*****	̊i[t@C̏擾	*****/

bool __fastcall	TCustomArchiver::FindNext(void)
{
	ZeroMemory(&FFileInfo,sizeof(FFileInfo));

	if ((ArcFindNext) AND (FhArc))
	then {
		if (ArcFindNext(FhArc,&FFileInfo)==0)
		then	return(true);
	}
	return(false);
}

/*----------------------------------------------*/
/*			TLhaNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TLha::TLha(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atLHA;
	Load("unlha32.dll","Unlha");
}

/*****	fXgN^	*****/

__fastcall	TLha::~TLha(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TLha::MakeOptions(void)
{
	AnsiString	S;
	int			i;

	if (FOptions->SystemFile)
	then	S+=" -a2";
	if (FOptions->Dialog==false)
	then	S+=" -n1";
	if (FOptions->IgnoreDir==false)
	then	S+=" -x1";
	if (FOptions->Update==false)
	then	S+=" -c1";
	if (FOptions->Overwrite)
	then	S+=" -m1";
	if (FOptions-> Recursive)
	then	S+=" -r2";
	if (!FOptions->Method.IsEmpty())
	then {
		S+=" -jm"+FOptions->Method;
	}
	if (!FOptions->WorkDir.IsEmpty())
	then {
		S+=" \"-w";
		S+=FOptions->WorkDir;
		S+="\"";
	}
	if (!FOptions->StartDate.IsEmpty())
	then {
		S+=" -jo"+FOptions->StartDate;
	}
	if (!FOptions->EndDate.IsEmpty())
	then {
		S+=" -job"+FOptions->EndDate;
	}
	if (FOptions->Exclusive->Count)
	then {
		for(i=0;	i<FOptions->Exclusive->Count;	i++)
		{
			S+=" -jx"+FOptions->Exclusive->Strings[i];
		}
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}
	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TLha::MakePackCommand(AnsiString Path)
{
	AnsiString	S;

	S="a ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TLha::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	S="e ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	return(S);
}

/*****	ɂ̐̌	*****/

int __fastcall	TLha::Check(AnsiString Path)
{
	AnsiString	S;

	S="t";
	if (FOptions->Dialog==false)
	then	S+=" -n1";
	if (FOptions-> Recursive)
	then	S+=" -r2";
	if (!FOptions->WorkDir.IsEmpty())
	then {
		S+=" \"-w";
		S+=FOptions->WorkDir;
		S+="\"";
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S+=" \""+FFileName;
	S+="\"";

	if (!Path.IsEmpty())
	then	S+=" "+Path;

	return(Command(S));
}

/*----------------------------------------------*/
/*			TZipNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TZip::TZip(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atZIP;
	Load("unzip32.dll","UnZip");
	UnZipUnZip=ArcCommand;
}

/*****	ZIP32.DLL̃[h	*****/

void __fastcall	TZip::LoadZip32(void)
{
	if (FZip32jHandle)
	then	return;

	FZip32jHandle=::LoadLibrary("zip32j.dll");
	if (FZip32jHandle==NULL)
	then {
		FZip32jHandle=(HMODULE)-1;
		return;
	}

	ZipZip=(TArcCommand)::GetProcAddress(FZip32jHandle,"Zip");
	ZipGetVersion=(TArcGetVersion)::GetProcAddress(FZip32jHandle,"ZipGetVersion");
	ZipGetRunning=(TArcGetRunning)::GetProcAddress(FZip32jHandle,"ZipGetRunning");
	ZipConfigDialog=(TArcConfigDialog)::GetProcAddress(FZip32jHandle,"ZipConfigDialog");
	ZipQueryEncryption=(TZipQueryEncryption)::GetProcAddress(FZip32jHandle,"ZipQueryEncryption");
	ZipSetOwnerWindowEx=(TArcSetOwnerWindowEx)::GetProcAddress(FZip32jHandle,"ZipSetOwnerWindowEx");

	if (ZipSetOwnerWindowEx)
	then	ZipSetOwnerWindowEx(FArchiver->Handle,NULL/*ArchiverCallBack*/);
}

/*****	fXgN^	*****/

__fastcall	TZip::~TZip(void)
{
	if (FZip32jHandle)
	then	FreeLibrary(FZip32jHandle);
}

/*****	ftHgݒ肷	*****/

bool __fastcall	TZip::ConfigDialog(int Mode,AnsiString &Option)
{
	bool		res=false;

	if (Mode==PACK_CONFIG_MODE)
	then {
		LoadZip32();

		if (ZipConfigDialog)
		then {
			int	sz=Option.Length();
			if (sz<520)
			then	sz=520;
			char    	*bf=new char[sz];
			bf[0]=0;
			strcpy(bf,Option.c_str());
			if (ZipConfigDialog(FParentWindow,bf,Mode)==TRUE)
			then	res=true;
			Option=bf;
			delete	bf;
		}
	}
	else {
		inherited::ConfigDialog(Mode,Option);
	}

	return(res);
}

/*****	Í\ǂ擾	*****/

bool __fastcall	TZip::QueryEncryption(void)
{
	LoadZip32();

	if (ZipQueryEncryption)
	then	return(ZipQueryEncryption());
	else	return(false);
}

/*****	s	*****/

int __fastcall	TZip::Command(AnsiString Cmd)
{
	if ((Cmd.IsEmpty()) OR (Cmd[1] != '!'))
	then {
		return(inherited::Command(Cmd));
	}

	Close();

	LoadZip32();

	if (ZipZip==NULL)
	then	return(-1);

	Cmd=Cmd.SubString(2,Cmd.Length()-1);
	Cmd=Cmd.Trim();

	char	*bf=new char[FOutBuffSize];
	int	res=ZipZip(FParentWindow,Cmd.c_str(),bf,FOutBuffSize);
	FOutput=bf;
	delete	bf;

	return(res);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TZip::MakePackCommand(AnsiString Path)
{
	AnsiString	S;

	if (FOptions->Update)
	then	S="-u";
	if (FOptions->SystemFile)
	then	S+=" -S";
	if (FOptions->Dialog==false)
	then	S+=" -q";
	if (FOptions->IgnoreDir)
	then	S+=" -D -j";
	if (FOptions-> Recursive)
	then	S+=" -r";
	if (!FOptions->Method.IsEmpty())
	then {
		S+=" -"+FOptions->Method;
	}
	if (!FOptions->Password.IsEmpty())
	then {
		S+=" \"-P"+FOptions->Password;
		S+=" \"";
	}
	if (!FOptions->WorkDir.IsEmpty())
	then {
		S+=" \"-b";
		S+=FOptions->WorkDir;
		S+="\"";
	}
	if (!FOptions->StartDate.IsEmpty())
	then {
		S+=" -t"+FOptions->StartDate;
	}
	if (!FOptions->EndDate.IsEmpty())
	then {
		S+=" -tt"+FOptions->EndDate;
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S="!"+S;

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TZip::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	if (FOptions->Update)
	then	S="-u";
	else	S="-x";
	if (FOptions->Dialog)
	then	S+=" -q";
	else	S+=" --i -q";
	if (FOptions->IgnoreDir)
	then	S+=" -j";
	if (FOptions->Overwrite)
	then	S+=" -o";
	if (!FOptions->Password.IsEmpty())
	then {
		S+=" \"-P"+FOptions->Password;
		S+=" \"";
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	k	*****/

int __fastcall	TZip::Pack(AnsiString Path)
{
	LoadZip32();

	if (ZipZip==NULL)
	then	return(-1);

	return(Command(MakePackCommand(Path)));
}

/*****		*****/

int __fastcall	TZip::Unpack(AnsiString Path)
{
	if (UnZipUnZip==NULL)
	then	return(-1);

	return(Command(MakeUnpackCommand(Path)));
}

/*****	̈k	*****/

int __fastcall	TZip::Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr)
{
	LoadZip32();

	if (ZipZip==NULL)
	then	return(-1);

	return(inherited::Pack(Path,bf,Size,Time,Attr));
}

/*****	։	*****/

int __fastcall	TZip::Unpack(AnsiString Path,void *bf,DWORD &Size,time_t *Time,WORD *Attr)
{
	if (UnZipUnZip==NULL)
	then	return(-1);

	return(inherited::Unpack(Path,bf,Size,Time,Attr));
}

/*****	ɂ̐̌	*****/

int __fastcall	TZip::Check(AnsiString Path)
{
	if (UnZipUnZip==NULL)
	then	return(false);

	AnsiString	S="-t";

	if (FOptions->Dialog)
	then	S+=" -q";
	else	S+=" --i -q";
	if (FOptions->IgnoreDir)
	then	S+=" -j";
	if (!FOptions->Password.IsEmpty())
	then {
		S+=" \"-P"+FOptions->Password;
		S+=" \"";
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(Command(S));
}

/*----------------------------------------------*/
/*			TCabNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TCab::TCab(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atCAB;
	Load("cab32.dll","Cab");
}

/*****	fXgN^	*****/

__fastcall	TCab::~TCab(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TCab::MakeOptions(void)
{
	AnsiString	S;
	int			i;

	if (FOptions->SystemFile==false)
	then	S+=" -g";
	if (FOptions->Dialog==false)
	then	S+=" -i";
	if (FOptions->IgnoreDir)
	then	S+=" -j";
	if (FOptions->Update)
	then	S+=" -n";
	if (FOptions->Overwrite)
	then	S+=" -o";
	if (FOptions-> Recursive)
	then	S+=" -r";
	if (!FOptions->Method.IsEmpty())
	then {
		S+=" -m"+FOptions->Method;
	}
	if (!FOptions->WorkDir.IsEmpty())
	then {
		S+=" \"-h";
		S+=FOptions->WorkDir;
		S+="\"";
	}
	if (!FOptions->StartDate.IsEmpty())
	then {
		S+=" -ys"+FOptions->StartDate;
	}
	if (!FOptions->EndDate.IsEmpty())
	then {
		S+=" -ye"+FOptions->EndDate;
	}
	if (FOptions->Exclusive->Count)
	then {
		for(i=0;	i<FOptions->Exclusive->Count;	i++)
		{
			S+=" -ze"+FOptions->Exclusive->Strings[i];
		}
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TCab::MakePackCommand(AnsiString Path)
{
	AnsiString	S="-a ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TCab::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S="-x ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	ɂ̐̌	*****/

int __fastcall	TCab::Check(AnsiString Path)
{
	AnsiString	S="-t ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(Command(S));
}

/*----------------------------------------------*/
/*			TTarNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TTar::TTar(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atTAR;
	Load("tar32.dll","Tar");
}

/*****	fXgN^	*****/

__fastcall	TTar::~TTar(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TTar::MakeOptions(void)
{
	AnsiString	S;

	if (FOptions->Dialog==false)
	then	S+=" --display-dialog=0";
	if (FOptions->IgnoreDir)
	then	S+=" --use-directory=0";
	if (!FOptions->Method.IsEmpty())
	then {
		S+=" -"+FOptions->Method;
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TTar::MakePackCommand(AnsiString Path)
{
	AnsiString	S="-c ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TTar::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S="-x ";
	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*----------------------------------------------*/
/*			TRarNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TRar::TRar(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atRAR;
	Load("unrar32.dll","Unrar");
}

/*****	fXgN^	*****/

__fastcall	TRar::~TRar(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TRar::MakeOptions(void)
{
	AnsiString	S;

	if (FOptions->Dialog==false)
	then	S+=" -y";
	if (FOptions->Update)
	then	S+=" -u";
	if (FOptions->Overwrite)
	then	S+=" -o";
	if (FOptions->Recursive)
	then	S+=" -s -r";
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TRar::MakePackCommand(AnsiString Path)
{
	return("");
}

/*****	k	*****/

int __fastcall	TRar::Pack(AnsiString Path)
{
	return(ERROR_NOT_SUPPORT);
}

/*****	ւ̈k	*****/

int __fastcall	TRar::Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr)
{
	return(ERROR_NOT_SUPPORT);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TRar::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	if (FOptions->IgnoreDir)
	then	S="-e ";
	else	S="-x ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	ɂ̐̌	*****/

int __fastcall	TRar::Check(AnsiString Path)
{
	AnsiString	S="-t ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(Command(S));
}

/*----------------------------------------------*/
/*			TArjNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TArj::TArj(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atARJ;
	Load("unarj32j.dll","Unarj");
}

/*****	fXgN^	*****/

__fastcall	TArj::~TArj(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TArj::MakeOptions(void)
{
	AnsiString	S;
	int			i;

	if (FOptions->Dialog==false)
	then	S+=" -i- -hm";
	if (FOptions->Update)
	then	S+=" -f+";
	if (FOptions->Overwrite)
	then	S+=" -y+ -ha+";
	if (FOptions->IgnoreDir)
	then	S+=" -hj+";
	if (FOptions->Recursive)
	then	S+=" -p1";
	if (FOptions->SystemFile==false)
	then	S+=" -a-";
	if (!FOptions->StartDate.IsEmpty())
	then {
		S+=" -o"+FOptions->StartDate;
	}
	if (!FOptions->EndDate.IsEmpty())
	then {
		S+=" -ob"+FOptions->EndDate;
	}
	if (FOptions->Exclusive->Count)
	then {
		for(i=0;	i<FOptions->Exclusive->Count;	i++)
		{
			S+=" -x"+FOptions->Exclusive->Strings[i];
		}
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TArj::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	S="x ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TArj::MakePackCommand(AnsiString Path)
{
	return("");
}

/*****	k	*****/

int __fastcall	TArj::Pack(AnsiString Path)
{
	return(ERROR_NOT_SUPPORT);
}

/*****	ւ̈k	*****/

int __fastcall	TArj::Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr)
{
	return(ERROR_NOT_SUPPORT);
}

/*****	ɂ̐̌	*****/

int __fastcall	TArj::Check(AnsiString Path)
{
	AnsiString	S;

	S="t ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(Command(S));
}

/*----------------------------------------------*/
/*			TBgaNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TBga::TBga(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atBGA;
	Load("Bga32.dll","Bga");
}

/*****	fXgN^	*****/

__fastcall	TBga::~TBga(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TBga::MakeOptions(void)
{
	AnsiString	S;

	if (FOptions->Dialog==false)
	then	S+=" -i";
	if (FOptions->Update)
	then	S+=" -n";
	if (FOptions->Overwrite)
	then	S+=" -o";
	if (FOptions->IgnoreDir)
	then	S+=" -j";
	if (FOptions->Recursive)
	then	S+=" -r";
	if (FOptions->SystemFile)
	then	S+=" -a";
	if (!FOptions->Method.IsEmpty())
	then {
		S+=" -l"+FOptions->Method;
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TBga::MakePackCommand(AnsiString Path)
{
	AnsiString	S="a ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TBga::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	S="x ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	ɂ̐̌	*****/

int __fastcall	TBga::Check(AnsiString Path)
{
	AnsiString	S;

	S="t ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(Command(S));
}

/*----------------------------------------------*/
/*			TGcaNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TGca::TGca(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atGCA;
	Load("UnGCA32.dll","UnGCA");
}

/*****	fXgN^	*****/

__fastcall	TGca::~TGca(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TGca::MakeOptions(void)
{
	AnsiString	S;

	if (FOptions->Dialog)
	then	S+=" -sx1";
	if (FOptions->Overwrite==false)
	then	S+=" -yx1";
	if (FOptions->IgnoreDir==false)
	then	S+=" -xx1";
	if (!FOptions->Password.IsEmpty())
	then {
		S+=" \"-p"+FOptions->Password;
		S+="\"";
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TGca::MakePackCommand(AnsiString Path)
{
	AnsiString	S="a ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
/*
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;
*/
	TStringList	*SList=new TStringList();
	AnsiString	s;
	int			i;
	
	AnsiString	CurDir=GetCurrentDir();
	AnsiString	BasePath=FBaseDir;
	if (!BasePath.IsEmpty())
	then {
		if (*(BasePath.AnsiLastChar())=='\\')
		then	BasePath=ExtractFileDir(BasePath);
		if (!BasePath.IsEmpty())
		then	SetCurrentDir(BasePath);
	}

	SList->CommaText=Path;
	for(i=0;	i<SList->Count;	i++)
	{
		s=SList->Strings[i];
		if (!BasePath.IsEmpty())
		then	s=ExpandFileName(s);						//΃pX̎擾
		S+=" "+s;
	}
	delete	SList;
	SetCurrentDir(CurDir);

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TGca::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	if (Path=="*.*")
	then	Path="";
	if (Path.IsEmpty())
	then	S="e ";
	else	S="ex ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*----------------------------------------------*/
/*			TYz1NX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TYz1::TYz1(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=atYZ1;
	Load("Yz1.dll","Yz1");
}

/*****	fXgN^	*****/

__fastcall	TYz1::~TYz1(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	TYz1::MakeOptions(void)
{
	AnsiString	S;

	if (FOptions->Dialog==false)
	then	S+=" -i1";
	if (FOptions->Update==false)
	then	S+=" -c1";
	if (FOptions->Overwrite)
	then	S+=" -y1";
	if (FOptions->IgnoreDir)
	then	S+=" -x0";
	if (FOptions->Recursive==false)
	then	S+=" -r0";
	if (!FOptions->Password.IsEmpty())
	then {
		S+=" \"-p"+FOptions->Password;
		S+="\"";
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	TYz1::MakePackCommand(AnsiString Path)
{
	AnsiString	S="c ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	TYz1::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S="x ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*----------------------------------------------*/
/*			T7ZipNX							*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	T7Zip::T7Zip(TComponent *Owner)
:TCustomArchiver(Owner)
{
	FType=at7ZIP;
	Load("7-zip32.dll","SevenZip");
}

/*****	fXgN^	*****/

__fastcall	T7Zip::~T7Zip(void)
{
}

/*****	IvV̍쐬	*****/

AnsiString __fastcall	T7Zip::MakeOptions(void)
{
	AnsiString	S;
	int			i;

	if (FZipMode)
	then	S+=" -tzip";
	if (FOptions->Dialog==false)
	then	S+=" -hide";
	if (FOptions->Overwrite)
	then	S+=" -aoa -y";
	if (FOptions->Recursive)
	then	S+=" -r0";
	if (!FOptions->Method.IsEmpty())
	then {
		S+=" -m"+FOptions->Method;
	}
	if (!FOptions->WorkDir.IsEmpty())
	then {
		S+=" \"-w";
		S+=FOptions->WorkDir;
		S+="\"";
	}
	if (!FOptions->Password.IsEmpty())
	then {
		S+=" \"-p"+FOptions->Password;
		S+="\"";
	}
	if (FOptions->Exclusive->Count)
	then {
		for(i=0;	i<FOptions->Exclusive->Count;	i++)
		{
			S+=" -x!"+FOptions->Exclusive->Strings[i];
		}
	}
	if (!FOptions->UserOption.IsEmpty())
	then {
		S+=" ";
		S+=FOptions->UserOption;
	}

	S=S.Trim();

	return(S);
}

/*****	kR}hC̍쐬	*****/

AnsiString __fastcall	T7Zip::MakePackCommand(AnsiString Path)
{
	AnsiString	S;

	if (FOptions->Update)
	then	S="u ";
	else	S="a ";

	S+=MakeOptions();

	if (FOptions->Update==false)
	then {
		if ((S.AnsiPos("-tzip")==0) AND (S.AnsiPos("-ms=off")==0))
		then	S+=" -ms=off";
	}

	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	𓀃R}hC̍쐬	*****/

AnsiString __fastcall	T7Zip::MakeUnpackCommand(AnsiString Path)
{
	AnsiString	S;

	if (FOptions->IgnoreDir)
	then	S="e ";
	else	S="x ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(S);
}

/*****	ɂ̐̌	*****/

int __fastcall	T7Zip::Check(AnsiString Path)
{
	AnsiString	S="t ";

	S+=MakeOptions();
	S+=" \""+FFileName;
	S+="\"";
	if (!FBaseDir.IsEmpty())
	then {
		S+=" \""+FBaseDir;
		if (*(FBaseDir.AnsiLastChar()) != '\\')
		then	S+="\\";
		S+="\"";
	}
	if (!Path.IsEmpty())
	then	S+=" "+Path;

	S=S.Trim();

	return(Command(S));
}

/*----------------------------------------------*/
/*			TArchiverNX	 					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TArchiver::TArchiver(TComponent *owner)
:TComponent(owner)
{
	Init();
}

/*****	RXgN^	*****/

__fastcall	TArchiver::TArchiver(TComponent *owner,AnsiString FileName)
:TComponent(owner)
{
	Init();
	SetFileName(FileName);
}

/*****		*****/

void	__fastcall	TArchiver::Init(void)
{
	FLock=new TCriticalSection();

	if (Owner)
	then	FParentWindow=((TWinControl*)Owner)->Handle;
	FOptions=new TArchiveOptions();

	WM_ARCEXTRACT=::RegisterWindowMessage("wm_arcextract");
	FHandle=AllocateHWnd(WndProc);

	FZipArchiver=at7ZIP;

//	FMode=M_NO_BACKGROUND_MODE;
}

/*****	fXgN^	*****/

__fastcall	TArchiver::~TArchiver(void)
{
	DeallocateHWnd(FHandle);

	delete	FOptions;

	if (FArchiver)
	then	delete	FArchiver;

	delete	FLock;
}

/*****	R[obN֐	*****/

bool	TArchiver::CallBack(UINT Msg,UINT State,void *Info)
{
	if (FOnProgress)
	then {
		bool	f=FOnProgress(this,State,(EXTRACTINGINFO*)Info);

		if (FAborted)
		then	f=false;

		return(f);
	}

	return(TRUE);
}

/*****	EBhEvV[W\	*****/

void __fastcall	TArchiver::WndProc(Messages::TMessage &Msg)
{
	if (Msg.Msg==WM_ARCEXTRACT)
	then {
		if (FOnProgress)
		then	Msg.Result=!FOnProgress(this,Msg.WParam,(EXTRACTINGINFO*)Msg.LParam);

		if (FAborted)
		then	Msg.Result=true;
	}
	else {
		Msg.Result=DefWindowProc(FHandle,Msg.Msg,Msg.WParam,Msg.LParam);
	}
}

/*****	bN	*****/

int __fastcall	TArchiver::Lock(void)
{
	if (FLockCount)
	then {
		if (MainThreadID==GetCurrentThreadId())
		then {
			while(FLockCount)
			{
				Application->ProcessMessages();
			}
		}
	}

	FLock->Enter();
	FLockCount++;

	return(FLockCount);
}

/*****	AbN	*****/

int __fastcall	TArchiver::Unlock(void)
{
	FLockCount--;
	FLock->Leave();

	return(FLockCount);
}

/*****	DLLA[h	*****/

void __fastcall	TArchiver::Unload(void)
{
	if (FArchiver)
	then {
		delete	FArchiver;
		FArchiver=NULL;
	}
}

/*****	A[JCo[^Cv̎擾	*****/

TArchiveType __fastcall	TArchiver::GetArchiveType(void)
{
	if (FArchiver)
	then {
		if ((FArchiver->Type==at7ZIP) AND (((T7Zip*)FArchiver)->ZipMode))
		then	return(atZIP);

		return(FArchiver->Type);
	}

	return(atUnknown);
}

/*****	A[JCo[^Cv̐ݒ	*****/

void __fastcall	TArchiver::SetArchiveType(TArchiveType Type)
{
	if ((FArchiver==NULL) OR (FArchiver->Type != Type))
	then {
		Unload();
		switch(Type)
		{
			case atLHA:
				FArchiver=new TLha(this);
				break;
			case atZIP:
				if (FZipArchiver==at7ZIP)
				then {
					FArchiver=new T7Zip(this);
					((T7Zip*)FArchiver)->ZipMode=true;
					if (FArchiver->Handle==NULL)
					then {
						FArchiver=new TZip(this);
					}
				}
				else {
					FArchiver=new TZip(this);
					if (FArchiver->Handle==NULL)
					then {
						FArchiver=new T7Zip(this);
						((T7Zip*)FArchiver)->ZipMode=true;
					}
				}
				break;
			case atCAB:
				FArchiver=new TCab(this);
				break;
			case atTAR:
				FArchiver=new TTar(this);
				break;
			case atRAR:
				FArchiver=new TRar(this);
				break;
			case atARJ:
				FArchiver=new TArj(this);
				break;
			case atBGA:
				FArchiver=new TBga(this);
				break;
			case atGCA:
				FArchiver=new TGca(this);
				break;
			case atYZ1:
				FArchiver=new TYz1(this);
				break;
			case at7ZIP:
				FArchiver=new T7Zip(this);
				break;
		}
		if (FArchiver)
		then {
			FArchiver->ParentWindow=FParentWindow;
			FArchiver->Options=FOptions;
			FArchiver->FileName=FFileName;
			FArchiver->BaseDir=FBaseDir;
			FArchiver->Mode=FMode;
		}
	}
}

/*****	Ƀt@Č	*****/

bool __fastcall	TArchiver::IsArchive(void)
{
	if ((FArchiver==NULL) OR (FFileName.IsEmpty()))
	then	return(false);

	return(FArchiver->IsArchive(FFileName));
}

/*****	gq珑Ƀt@C^Cv擾	*****/

TArchiveType __fastcall	TArchiver::GetArchiveTypeFromExt(AnsiString FileName)
{
	AnsiString		S=AnsiLowerCase(ExtractFileExt(FileName));

	if ((S==".lzh") OR (S==".lhz") OR (S==".lzs"))
	then {
		return(atLHA);
	}
	else if ((S==".zip") OR (S==".jar"))
	then {
		return(atZIP);
	}
	else if (S==".cab")
	then {
		return(atCAB);
	}
	else if ((S==".tar") OR (S==".tgz") OR (S==".taz")
		OR (S==".gz") OR (S==".bz2") OR (S==".z")
		OR (S==".cpio") OR (S==".rpm") OR (S==".deb"))
	then {
		return(atTAR);
	}
	else if (S==".rar")
	then {
		return(atRAR);
	}
	else if (S==".arj")
	then {
		return(atARJ);
	}
	else if ((S==".gza") OR (S==".bza"))
	then {
		return(atBGA);
	}
	else if (S==".gca")
	then {
		return(atGCA);
	}
	else if (S==".yz1")
	then {
		return(atYZ1);
	}
	else if (S==".7z")
	then {
		return(at7ZIP);
	}

	return(atUnknown);
}

/*****	Ƀt@Č	*****/

TArchiveType __fastcall	TArchiver::IsArchive(AnsiString FileName)
{
	TArchiveType	type;

	type=GetArchiveTypeFromExt(FileName);

	if (type != atUnknown)
	then {
		SetArchiveType(type);
		if ((FArchiver) AND (FArchiver->IsArchive(FileName)))
		then	return(type);
	}

	SetArchiveType(atLHA);
	if (FArchiver->IsArchive(FileName))
	then	return(atLHA);
	SetArchiveType(atZIP);
	if (FArchiver->IsArchive(FileName))
	then	return(atZIP);
	SetArchiveType(atCAB);
	if (FArchiver->IsArchive(FileName))
	then	return(atCAB);
	SetArchiveType(atTAR);
	if (FArchiver->IsArchive(FileName))
	then	return(atTAR);
	SetArchiveType(atRAR);
	if (FArchiver->IsArchive(FileName))
	then	return(atRAR);
	SetArchiveType(atARJ);
	if (FArchiver->IsArchive(FileName))
	then	return(atARJ);
	SetArchiveType(atBGA);
	if (FArchiver->IsArchive(FileName))
	then	return(atBGA);
	SetArchiveType(atGCA);
	if (FArchiver->IsArchive(FileName))
	then	return(atGCA);
	SetArchiveType(atYZ1);
	if (FArchiver->IsArchive(FileName))
	then	return(atYZ1);
	SetArchiveType(at7ZIP);
	if (FArchiver->IsArchive(FileName))
	then	return(at7ZIP);

	Unload();

	return(atUnknown);
}

/*****	Ƀt@C̐ݒ	*****/

void __fastcall	TArchiver::SetFileName(AnsiString FileName)
{
	AnsiString	S;

	FFileName=FileName;

	if (FileName.IsEmpty())
	then {
		Unload();
		return;
	}

	if (FileExists(FileName))
	then {
		if (IsArchive(FileName)==atUnknown)
		then	SetArchiveType(GetArchiveTypeFromExt(FileName));
	}
	else {
		SetArchiveType(GetArchiveTypeFromExt(FileName));
	}

	if (FArchiver)
	then	FArchiver->FileName=FileName;
}

/*****	\؂	*****/

bool __fastcall	TArchiver::IsEnabled(void)
{
	if (FArchiver==NULL)
	then	return(false);

	return(FArchiver->Enabled);
}

/*****	쒆̎擾	*****/

bool __fastcall	TArchiver::GetRunning(void)
{
	if (FArchiver==NULL)
	then	return(false);

	return(FArchiver->Running);
}

/*****	eEBhE̐ݒ	*****/

void __fastcall	TArchiver::SetParentWindow(HWND hWnd)
{
	FParentWindow=hWnd;
	if (FArchiver)
	then	FArchiver->ParentWindow=FParentWindow;
}

/*****	I[v	*****/

bool __fastcall	TArchiver::Open(DWORD mode)
{
	if (FArchiver==NULL)
	then	return(false);

	if (mode==(DWORD)-1)
	then	mode=FMode;

	return(FArchiver->Open(FFileName,mode));
}

/*****	N[Y	*****/

void __fastcall	TArchiver::Close(void)
{
	if (FArchiver==NULL)
	then	return;

	FArchiver->Close();
}

/*****	[h̐ݒ	*****/

void __fastcall	TArchiver::SetMode(DWORD mode)
{
	FMode=mode;
	if (FArchiver)
	then	FArchiver->Mode=FMode;
}

/*****	t@C̎擾	*****/

INDIVIDUALINFO* __fastcall	TArchiver::GetFileInfo(void)
{
	if (FArchiver==NULL)
	then	return(NULL);

	return(FArchiver->FileInfo);
}


/*****	ʂ̎擾	*****/

AnsiString __fastcall	TArchiver::GetOutput(void)
{
	if (FArchiver==NULL)
	then	return("");

	return(FArchiver->Output);
}

/*****	fBNg̐ݒ	*****/

void __fastcall	TArchiver::SetBaseDir(AnsiString Dir)
{
	FBaseDir=Dir;

	if (FArchiver)
	then {
		FArchiver->BaseDir=Dir;
	}
}

/*****	s	*****/

int __fastcall	TArchiver::Command(AnsiString Cmd)
{
	if (FArchiver==NULL)
	then	return(-1);

	Close();

	return(FArchiver->Command(Cmd));
}

/*****	Č	*****/

void __fastcall	TArchiver::Research(AnsiString Filter)
{
	if (FArchiver)
	then {
		FArchiver->Research(Filter);
	}
}

/*****		*****/

bool __fastcall	TArchiver::Find(void)
{
	if (FArchiver==NULL)
	then	return(false);

	return(FArchiver->Find());
}

/*****	pX␳	*****/

AnsiString __fastcall	TArchiver::CorrectPath(AnsiString Path)
{
	AnsiString	S;
	char		*p,bf[130];
	int			n;

	Path=StringReplace(Path,"\\","/",TReplaceFlags()<<rfReplaceAll);

	switch(FArchiver->Type)
	{
		case atZIP:
//		case atCAB:           									//CAB32.dll̃ftHg͐K\Ȃ
																//K\Ȃ
			Path=StringReplace(Path,"[","\\[",TReplaceFlags()<<rfReplaceAll);
			Path=StringReplace(Path,"]","\\]",TReplaceFlags()<<rfReplaceAll);
			break;
	}

	return(Path);
}

/*****	k	*****/

int __fastcall	TArchiver::Pack(AnsiString Path)
{
	if (FArchiver==NULL)
	then	return(-1);

	Path=CorrectPath(Path);

	int	res=FArchiver->Pack(Path);

	return(res);
}

/*****		*****/

int __fastcall	TArchiver::Unpack(AnsiString Path)
{
	if (FArchiver==NULL)
	then	return(-1);

	Path=CorrectPath(Path);

	int	res=FArchiver->Unpack(Path);

	return(res);
}

/*****	̈k	*****/

int __fastcall	TArchiver::Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr)
{
	DWORD	sz=Size;

	if (FArchiver==NULL)
	then	return(-1);

	Path=CorrectPath(Path);

	int	res=FArchiver->Pack(Path,bf,Size,Time,Attr);

	return(res);
}


/*****	ւ̉	*****/

int __fastcall	TArchiver::Unpack(AnsiString Path,void *bf,DWORD &Size,time_t *Time,WORD *Attr)
{
	DWORD	sz=Size;

	if (FArchiver==NULL)
	then	return(-1);

	Path=CorrectPath(Path);

	int	res=FArchiver->Unpack(Path,bf,Size,Time,Attr);

	return(res);
}

/*****	ɂ̐̌	*****/

int __fastcall	TArchiver::Check(AnsiString Path)
{
	if (FArchiver==NULL)
	then	return(-1);

	Close();

	Path=CorrectPath(Path);

	int	res=FArchiver->Check(Path);

	return(res);
}

/*****	t@CXg̎擾	*****/

TStringList* __fastcall	TArchiver::GetFileList(TStringList *SList)
{
	if (FArchiver==NULL)
	then	return(NULL);

	if (SList==NULL)
	then	SList=new TStringList();

	SList->Clear();

	Research("*.*");
	while(Find())
	{
		SList->Add(FArchiver->FileInfo->szFileName);
	}
    Close();

	return(SList);
}

/*****	End	****/

