/*	Filename:Archiver.h							*/
/************************************************/
/*												*/
/*					TArchiver					*/
/*												*/
/*			A[JCo[R|[lg			*/
/*												*/
/*					Ver.1.52					*/
/*												*/
/*		Copyright(C) 2002-2003 by DELTA SOFT	*/
/*												*/
/************************************************/
/*
A[JCo[
http://www.csdinc.co.jp/archiver/
*/
/*----------------------------------------------*/
/*						`						*/
/*----------------------------------------------*/

#ifndef ArchiverH
#define ArchiverH

#include	<vcl\vcl.h>
#include	<time.h>
#include	<SyncObjs.hpp>

namespace ArchiverN
{

#ifndef ARC_DECSTRACT
#define ARC_DECSTRACT

#ifndef FNAME_MAX32
#define FNAME_MAX32		512
#endif

typedef	HGLOBAL	HARC;

typedef struct {
	DWORD			dwOriginalSize;		/* t@C̃TCY */
	DWORD			dwCompressedSize;	/* k̃TCY */
	DWORD			dwCRC;				/* i[t@C̃`FbNT */
	UINT			uFlag;				/*  */
	UINT			uOSType;			/* ɍ쐬Ɏgꂽnr */
	WORD			wRatio;				/* k */
	WORD			wDate;				/* i[t@C̓t(DOS `) */
	WORD			wTime;				/* i[t@C̎(DOS `) */
	char			szFileName[FNAME_MAX32 + 1];	/* ɖ */
	char			dummy1[3];
	char			szAttribute[8];		/* i[t@C̑(ɌŗL) */
	char			szMode[8];			/* i[t@C̊i[[h(ɌŗL) */
}	INDIVIDUALINFO, *LPINDIVIDUALINFO;

typedef struct {
	DWORD			dwFileSize;							/* i[t@C̃TCY */
	DWORD			dwWriteSize;						/* ݃TCY */
	char			szSourceFileName[FNAME_MAX32 + 1];	/* i[t@C */
	char			dummy1[3];
	char			szDestFileName[FNAME_MAX32 + 1];	/* 𓀐܂͈kpX */
	char			dummy[3];
}	EXTRACTINGINFO, *LPEXTRACTINGINFO;

typedef struct {
	EXTRACTINGINFO	exinfo;				/* EXTRACTINGINFO \ */
	DWORD			dwCompressedSize;	/* i[t@C̈kTCY */
	DWORD			dwCRC;				/* i[t@C̃`FbNT */
	UINT			uOSType;			/* t@Ci[ۂɎgꂽnr */
	WORD			wRatio;				/* i[t@C̈k */
	WORD			wDate;				/* i[t@C̍XVt(DOS `) */
	WORD			wTime;				/* i[t@C̍XV(DOS `) */
	char			szAttribute[8];		/* i[t@C̑ */
	char			szMode[8];			/* k\bh̕ */
}	EXTRACTINGINFOEX, *LPEXTRACTINGINFOEX;

#endif			//ARC_DECSTRACT

#if !defined(CHECKARCHIVE_RAPID)
#define	CHECKARCHIVE_RAPID		0	/* Ȉ */
#define	CHECKARCHIVE_BASIC		1	/* W(SẴwb_) */
#define	CHECKARCHIVE_FULLCRC	2	/* S(i[t@C CRC `FbN) */
	/* ȉ̃tO͏LƑgݍ킹ĎgpB*/
#define CHECKARCHIVE_RECOVERY	4	/* jwb_ǂݔ΂ď */
#define CHECKARCHIVE_SFX		8	/* SFX ǂԂ */
#define CHECKARCHIVE_ALL		16	/* t@C̍Ō܂Ō */
#endif

#if !defined(UNPACK_CONFIG_MODE)
#define	UNPACK_CONFIG_MODE		1	/* 𓀌n̐ݒ */
#define PACK_CONFIG_MODE		2	/* kn̐ݒ */
#endif

#if !defined(ARCEXTRACT_BEGIN)
#define	ARCEXTRACT_BEGIN		0	/* Yt@C̏̊Jn */
#define	ARCEXTRACT_INPROCESS	1	/* Yt@C̓WJ */
#define	ARCEXTRACT_END			2	/* IA֘AJ */
#define ARCEXTRACT_OPEN			3	/* Yɂ̏̊Jn */
#define ARCEXTRACT_COPY			4	/* [Nt@C̏߂ */
#endif

#if !defined(EXTRACT_FOUND_FILE)
/* MODE (for UnarjOpenArchive) */
#define M_INIT_FILE_USE			0x00000001L	/* WXg̐ݒgp */
#define M_REGARDLESS_INIT_FILE	0x00000002L	/* WXg̐ݒgpȂ */
#define M_NO_BACKGROUND_MODE	0x00000004L	/* obNOEh֎~ */
#define M_NOT_USE_TIME_STAMP	0x00000008L
#define M_EXTRACT_REPLACE_FILE	0x00000010L
#define M_EXTRACT_NEW_FILE		0x00000020L
#define M_EXTRACT_UPDATE_FILE	0x00000040L
#define M_CHECK_ALL_PATH		0x00000100L	/* iȃt@CT[` */
#define M_CHECK_FILENAME_ONLY	0x00000200L	/* iȃt@CT[`sȂ */
#define M_CHECK_DISK_SIZE		0x00000400L
#define M_REGARDLESS_DISK_SIZE	0x00000800L
#define M_USE_DRIVE_LETTER		0x00001000L	/* hCui[ */
#define M_NOT_USE_DRIVE_LETTER	0x00002000L	/* hCui[Ȃ */
#define M_INQUIRE_DIRECTORY		0x00004000L
#define M_NOT_INQUIRE_DIRECTORY 0x00008000L
#define M_INQUIRE_WRITE			0x00010000L
#define M_NOT_INQUIRE_WRITE		0x00020000L
#define M_CHECK_READONLY		0x00040000L
#define M_REGARDLESS_READONLY	0x00080000L
#define M_REGARD_E_COMMAND		0x00100000L
#define M_REGARD_X_COMMAND		0x00200000L
#define M_ERROR_MESSAGE_ON		0x00400000L	/* G[bZ[W\ */
#define M_ERROR_MESSAGE_OFF		0x00800000L	/* G[bZ[W\Ȃ */
#define M_BAR_WINDOW_ON			0x01000000L
#define M_BAR_WINDOW_OFF		0x02000000L
#define M_CHECK_PATH			0x04000000L
#define M_RECOVERY_ON			0x08000000L	/* jwb_̓ǂݔ΂ */
#define M_MAKE_INDEX_FILE		0x10000000L
#define M_NOT_MAKE_INDEX_FILE	0x20000000L
#define EXTRACT_FOUND_FILE		0x40000000L	/* ꂽt@C */
#define EXTRACT_NAMED_FILE		0x80000000L	/* w肵t@C */
#endif /* EXTRACT_FOUND_FILE */

#if !defined(SFX_NOT)
#define SFX_NOT					0	/* ʏ̏ */

#define SFX_DOS_S				1		/* LHA's SFX n (small) */
#define SFX_DOS_204S			1		/* LHA's SFX 2.04S ȍ~ */
#define SFX_DOS_213S			1		/* LHA's SFX 2.04S ȍ~ */
#define SFX_DOS_250S			2		/* LHA's SFX 2.50S ȍ~ */
#define SFX_DOS_260S			3		/* LHA's SFX 2.60S ȍ~ */
#define SFX_DOS_265S			3		/* LHA's SFX 2.60S ȍ~ */

#define SFX_DOS_L				51		/* LHA's SFX n (large) */
#define SFX_DOS_204L			51		/* LHA's SFX 2.04L ȍ~ */
#define SFX_DOS_213L			51		/* LHA's SFX 2.04L ȍ~ */
#define SFX_DOS_250L			52		/* LHA's SFX 2.50L ȍ~ */
#define SFX_DOS_260L			53		/* LHA's SFX 2.60L ȍ~ */
#define SFX_DOS_265L			53		/* LHA's SFX 2.60L ȍ~ */

#define SFX_DOS_LARC			201		/* SFX by LARC n */
#define SFX_DOS_LARC_S			201		/* SFX by LARC (small) */
#define SFX_DOS_LARC_L			202		/* SFX by LARC (large) */

#define SFX_DOS_LHARC			301		/* LHarc's SFX n */
#define SFX_DOS_LHARC_S			301		/* LHarc's SFX (small) */
#define SFX_DOS_LHARC_L			351		/* LHarc's SFX (large) */

#define SFX_WIN16_213			1001	/* LHA's SFX 2.13.w16 n */
#define SFX_WIN16_213_1			1001	/* WinSFX 2.13.w16.1 */
#define SFX_WIN16_213_2			1002	/* WinSFX 2.13.w16.2 */
#define SFX_WIN16_213_3			1003	/* WinSFX 2.13.w16.3 ȍ~ */

#define SFX_WIN16_250			1011	/* LHA's SFX 2.50.w16 n */
#define SFX_WIN16_250_1			1011	/* WinSFXM 2.50.w16.0001 ȍ~ */
#define SFX_WIN16_255_1			1021	/* WinSFXM 2.55.w16.0001 ȍ~ */

#define SFX_WIN32_213			2001	/* LHA's SFX 2.13.w32 n */
#define SFX_WIN32_213_1			2001	/* WinSFX32 2.13.w32.1 ȍ~ */
#define SFX_WIN32_213_3			2002	/* WinSFX32 2.13.w32.3 ȍ~ */

#define SFX_WIN32_214_1			2003	/* WinSFX32 2.14.w32.0001 ȍ~ */

#define SFX_WIN32_250			2011	/* LHA's SFX 2.50.w32 n */
#define SFX_WIN32_250_1			2011	/* WinSFX32M 2.50.w32.0001 ȍ~ */
#define SFX_WIN32_250_6			2012	/* WinSFX32M 2.50.w32.0006 ȍ~ */

#define SFX_LZHSFX				2051	/* LZHSFX n */
#define SFX_LZHSFX_1002			2051	/* LZHSFX 1.0.0.2 ȍ~ */
#define SFX_LZHSFX_1100			2052	/* LZHSFX 1.1.0.0 ȍ~ */

#define SFX_LZHAUTO				2101	/* LZHAUTO n */
#define SFX_LZHAUTO_0002		2101	/* LZHAUTO 0.0.0.2 ȍ~ */
#define SFX_LZHAUTO_1000		2102	/* LZHAUTO 1.0.0.0 ȍ~ */
#define SFX_LZHAUTO_1002		2102	/* LZHAUTO 1.0.0.0 ȍ~ */
#define SFX_LZHAUTO_1100		2103	/* LZHAUTO 1.1.0.0 ȍ~ */

#define SFX_WIN32_LHASA			3001	/* Lhasa CXg[ */

#define SFX_DOS_UNKNOWN			9901	/* FłȂ DOS SFX */
#define SFX_WIN16_UNKNOWN		9911	/* FłȂ Win16 SFX */
#define SFX_WIN32_UNKNOWN		9921	/* FłȂ Win32 SFX */
#endif

#ifndef FA_RDONLY
/* Attribute */
#define FA_RDONLY				0x01	/* ݕی쑮 */
#define FA_HIDDEN				0x02	/* B */
#define FA_SYSTEM				0x04	/* VXe */
#define FA_LABEL				0x08	/* {[Ex */
#define FA_DIREC				0x10	/* fBNg */
#define FA_ARCH					0x20	/* A[JCu */
#endif

#if !defined(SFXFLAG_AUTO)
#define SFXFLAG_AUTO			0x0001
#define SFXFLAG_OVERWRITE		0x0002
#define SFXFLAG_CHECKCRC		0x0004
#define SFXFLAG_CHECKTIME		0x0008
#define SFXFLAG_ATTRIBUTE		0x0010
#define SFXFLAG_NO_AUTO			0x0100
#define SFXFLAG_NO_OVERWRITE	0x0200
#define SFXFLAG_NO_CHECKCRC		0x0400
#define SFXFLAG_NO_CHECKTIME	0x0800
#define SFXFLAG_NO_ATTRIBUTE	0x1000
#define SFXFLAG_NO_WAIT			0x2000
#endif

#if !defined(ERROR_START)
#define ERROR_START				0x8000
/* WARNING */
#define ERROR_DISK_SPACE		0x8005
#define ERROR_READ_ONLY			0x8006
#define ERROR_USER_SKIP			0x8007
#define ERROR_UNKNOWN_TYPE		0x8008
#define ERROR_METHOD			0x8009
#define ERROR_PASSWORD_FILE		0x800A
#define ERROR_VERSION			0x800B
#define ERROR_FILE_CRC			0x800C
#define ERROR_FILE_OPEN			0x800D
#define ERROR_MORE_FRESH		0x800E
#define ERROR_NOT_EXIST			0x800F
#define ERROR_ALREADY_EXIST		0x8010
#define ERROR_TOO_MANY_FILES	0x8011
/* ERROR */
#define ERROR_MAKEDIRECTORY		0x8012
#define ERROR_CANNOT_WRITE		0x8013
#define ERROR_HUFFMAN_CODE		0x8014
#define ERROR_COMMENT_HEADER	0x8015
#define ERROR_HEADER_CRC		0x8016
#define ERROR_HEADER_BROKEN		0x8017
#define ERROR_ARC_FILE_OPEN		0x8018
#define ERROR_NOT_ARC_FILE		0x8019
#define ERROR_CANNOT_READ		0x801A
#define ERROR_FILE_STYLE		0x801B
#define ERROR_COMMAND_NAME		0x801C
#define ERROR_MORE_HEAP_MEMORY	0x801D
#define ERROR_ENOUGH_MEMORY		0x801E
#if !defined(ERROR_ALREADY_RUNNING)
#define ERROR_ALREADY_RUNNING	0x801F
#endif
#define ERROR_USER_CANCEL		0x8020
#define ERROR_HARC_ISNOT_OPENED	0x8021
#define ERROR_NOT_SEARCH_MODE	0x8022
#define ERROR_NOT_SUPPORT		0x8023
#define ERROR_TIME_STAMP		0x8024
#define ERROR_TMP_OPEN			0x8025
#define ERROR_LONG_FILE_NAME	0x8026
#define ERROR_ARC_READ_ONLY		0x8027
#define ERROR_SAME_NAME_FILE	0x8028
#define ERROR_NOT_FIND_ARC_FILE 0x8029
#define ERROR_RESPONSE_READ		0x802A
#define ERROR_NOT_FILENAME		0x802B
#define ERROR_TMP_COPY			0x802C
#define ERROR_EOF				0x802D
#define ERROR_ADD_TO_LARC		0x802E
#define ERROR_TMP_BACK_SPACE	0x802F
#define ERROR_SHARING			0x8030
#define ERROR_NOT_FIND_FILE		0x8031
#define ERROR_LOG_FILE			0x8032
#define	ERROR_NO_DEVICE			0x8033
#define ERROR_GET_ATTRIBUTES	0x8034
#define ERROR_SET_ATTRIBUTES	0x8035
#define ERROR_GET_INFORMATION	0x8036
#define ERROR_GET_POINT			0x8037
#define ERROR_SET_POINT			0x8038
#define ERROR_CONVERT_TIME		0x8039
#define ERROR_GET_TIME			0x803a
#define ERROR_SET_TIME			0x803b
#define ERROR_CLOSE_FILE		0x803c
#define ERROR_HEAP_MEMORY		0x803d
#define ERROR_HANDLE			0x803e
#define ERROR_TIME_STAMP_RANGE	0x803f
#define ERROR_MAKE_ARCHIVE		0x8040
#define ERROR_NOT_CONFIRM_NAME	0x8041
#define ERROR_UNEXPECTED_EOF	0x8042
#define ERROR_INVALID_END_MARK	0x8043
#define ERROR_INVOLVED_LZH		0x8044
#define ERROR_NO_END_MARK		0x8045
#define ERROR_HDR_INVALID_SIZE	0x8046
#define ERROR_UNKNOWN_LEVEL		0x8047
#define ERROR_BROKEN_DATA		0x8048

#define ERROR_END	ERROR_BROKEN_DATA
#endif /* ERROR_START */

#define	ERROR_ARCMSG_END	(ERROR_END & 0x7FFF)

class	TArchiver;

/*----------------------------------------------*/
/*			TArchiveOptionsNX				*/
/*----------------------------------------------*/

class	TArchiveOptions
{
private:
	bool			FSystemFile;					//System/Hidden
	bool			FDialog;						//i󋵂_CAO\
	bool			FIgnoreDir;						//fBNg\𖳎
	bool			FUpdate;						//Vt@Ĉ
	bool			FOverwrite;						//㏑
	bool			FRecursive;						//ċAI
	AnsiString		FWorkDir;						//ƃfBNg̎w
	AnsiString		FMethod;						//k
	AnsiString		FPassword;						//pX[h
	AnsiString		FStartDate;						//Jnw
	AnsiString		FEndDate;						//Iw
	TStringList*	FExclusive;						//Ot@CXg
	AnsiString		FUserOption;					//[U[ݒIvV

protected:
	void __fastcall	SetExclusive(TStringList* List);

public:
	__fastcall	TArchiveOptions(void);
	__fastcall	~TArchiveOptions(void);
	void __fastcall	Init(void);

	__property	bool			SystemFile={read=FSystemFile,write=FSystemFile};
	__property	bool			Dialog={read=FDialog,write=FDialog};
	__property	bool			IgnoreDir={read=FIgnoreDir,write=FIgnoreDir};
	__property	bool			Update={read=FUpdate,write=FUpdate};
	__property	bool			Overwrite={read=FOverwrite,write=FOverwrite};
	__property	bool			Recursive={read=FRecursive,write=FRecursive};
	__property	AnsiString		Method={read=FMethod,write=FMethod};
	__property	AnsiString		WorkDir={read=FWorkDir,write=FWorkDir};
	__property	AnsiString		StartDate={read=FStartDate,write=FStartDate};
	__property	AnsiString		EndDate={read=FEndDate,write=FEndDate};
	__property	AnsiString		Password={read=FPassword,write=FPassword};
	__property	TStringList*	Exclusive={read=FExclusive,write=SetExclusive};
	__property	AnsiString		UserOption={read=FUserOption,write=FUserOption};
};

/*----------------------------------------------*/
/*			TCustomArchiverNX				*/
/*----------------------------------------------*/

typedef	BOOL CALLBACK ARCHIVERPROC(HWND hwnd,UINT Msg,UINT State,void *Info);
typedef	ARCHIVERPROC *LPARCHIVERPROC;

typedef	int (WINAPI* TArcCommand)(const HWND hWnd,LPCSTR szCmdLine,LPSTR szOutput,const DWORD dwSize);
typedef	WORD (WINAPI* TArcGetVersion)(void);
typedef	BOOL (WINAPI* TArcQueryFunctionList)(const int iFunction);
typedef	BOOL (WINAPI* TArcCheckArchive)(LPCSTR szFileName,const int iMode);
typedef	BOOL (WINAPI* TArcGetRunning)(VOID);
typedef	BOOL (WINAPI* TArcGetBackGroundMode)(VOID);
typedef	BOOL (WINAPI* TArcSetBackGroundMode)(const BOOL bBackGroundMode);
typedef	BOOL (WINAPI* TArcGetCursorMode)(VOID);
typedef	BOOL (WINAPI* TArcSetCursorMode)(const BOOL CursorMode);
typedef	WORD (WINAPI* TArcGetCursorInterval)(VOID);
typedef	BOOL (WINAPI* TArcSetCursorInterval)(const WORD Interval);
typedef	int (WINAPI* TArcGetFileCount)(LPCSTR szArcFile);
typedef	int (WINAPI* TArcExtractMem)(const HWND hwnd, LPCSTR szCmdLine,LPBYTE szBuffer, const DWORD dwSize, long *lpTime,LPWORD _lpwAttr, LPDWORD lpdwWriteSize);
typedef	int (WINAPI* TArcCompressMem)(const HWND hwnd, LPCSTR szCmdLine,const LPBYTE szBuffer, const DWORD dwSize,const long *_lpTime, const LPWORD lpwAttr,LPDWORD lpdwWriteSize);
typedef	BOOL (WINAPI* TArcConfigDialog)(const HWND hWnd,LPSTR szOptionBuffer,const int iMode);
typedef	HARC (WINAPI* TArcOpenArchive)(const HWND hWnd,LPCSTR szFileName,const DWORD dwMode);
typedef	int (WINAPI* TArcCloseArchive)(HARC hArc);
typedef	int (WINAPI* TArcFindFirst)(HARC hArc,LPCSTR szWildName,LPINDIVIDUALINFO lpSubInfo);
typedef	int	(WINAPI* TArcFindNext)(HARC hArc,LPINDIVIDUALINFO lpSubInfo);
typedef	BOOL (WINAPI* TArcSetOwnerWindowEx)(const HWND hwnd,LPARCHIVERPROC lpArcProc);

enum	TArchiveType	{atUnknown,atLHA,atZIP,atCAB,atTAR,atRAR,atARJ,atBGA,atGCA,atYZ1,at7ZIP,atJACK,atBELL,atISH};
extern	char	*ArchiveTypeStr[];

class	TCustomArchiver:public TComponent
{
private:
protected:
	TArchiver	*FArchiver;				//A[JCo[NX
	TArchiveType	FType;				//A[JCo[^Cv
	HMODULE		FHandle;				//DLLnh
	HWND		FParentWindow;			//eEBhEnh
	AnsiString	FFileName;				//ɖ
	TArchiveOptions*	FOptions;		//IvV
	AnsiString	FBaseDir;				//fBNg
	HARC		FhArc;					//Ƀnh
	DWORD		FMode;					//Openɓn[h
	AnsiString	FOutput;				//o̓obt@
	int			FOutBuffSize;			//o̓obt@TCY
	int			FFindFirst;				//tO
	INDIVIDUALINFO	FFileInfo;			//t@C

	TArcCommand				ArcCommand;
	TArcGetVersion			ArcGetVersion;
	TArcQueryFunctionList	ArcQueryFunctionList;
	TArcCheckArchive		ArcCheckArchive;
	TArcGetRunning			ArcGetRunning;
	TArcGetBackGroundMode	ArcGetBackGroundMode;
	TArcSetBackGroundMode	ArcSetBackGroundMode;
	TArcGetCursorMode		ArcGetCursorMode;
	TArcSetCursorMode		ArcSetCursorMode;
	TArcGetCursorInterval	ArcGetCursorInterval;
	TArcSetCursorInterval	ArcSetCursorInterval;
	TArcGetFileCount		ArcGetFileCount;
	TArcExtractMem			ArcExtractMem;
	TArcCompressMem			ArcCompressMem;
	TArcConfigDialog		ArcConfigDialog;
	TArcOpenArchive			ArcOpenArchive;
	TArcCloseArchive		ArcCloseArchive;
	TArcFindFirst			ArcFindFirst;
	TArcFindNext			ArcFindNext;
	TArcSetOwnerWindowEx	ArcSetOwnerWindowEx;

	virtual	void __fastcall	Load(AnsiString FileName,AnsiString Head);
	bool __fastcall	IsEnabled(void)
	{
		return((bool)FHandle);
	}
	INDIVIDUALINFO* __fastcall	GetFileInfo(void)
	{
		return(&FFileInfo);
	}

	virtual	WORD __fastcall	GetVersion(void);
	virtual	bool __fastcall	GetRunning(void);
	virtual	AnsiString __fastcall	MakeOptions(void);
	virtual	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	virtual	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);
	virtual	void __fastcall	SetFileName(AnsiString Path);
	virtual	int __fastcall	GetCount(void);
	virtual bool __fastcall	GetBackGroundMode(void);
	virtual	bool __fastcall	SetBackGroundMode(bool Mode);
	virtual	bool __fastcall	GetCursorMode(void);
	virtual	bool __fastcall	SetCursorMode(bool Mode);
	virtual	WORD __fastcall	GetCursorInterval(VOID);
	virtual	bool __fastcall	SetCursorInterval(WORD Interval);
	virtual	bool __fastcall	FindFirst(AnsiString Filter);
	virtual	bool __fastcall	FindNext(void);

public:
	__fastcall	TCustomArchiver(TComponent *Owner);
	__fastcall	~TCustomArchiver(void);

	virtual FARPROC __fastcall	GetProcAddress(AnsiString Name);
	virtual	bool __fastcall	QueryFunction(int Function);
	virtual	bool __fastcall	ConfigDialog(int Mode,AnsiString &Option);
	virtual	int __fastcall	Command(AnsiString Cmd);
	virtual	bool __fastcall	Open(AnsiString FileName,DWORD Mode=0);
	virtual	void __fastcall	Close(void);
	virtual	void __fastcall	Research(AnsiString Filter);
	virtual	bool __fastcall	Find(void);
	virtual	int __fastcall	Pack(AnsiString Path);
	virtual	int __fastcall	Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time=0,WORD Attr=FA_ARCH);
	virtual	int __fastcall	Unpack(AnsiString Path);
	virtual	int __fastcall	Unpack(AnsiString Path,void *bf,DWORD &Size,time_t *Time=NULL,WORD *Attr=NULL);
	virtual	bool __fastcall	IsArchive(AnsiString FileName,DWORD Mode=CHECKARCHIVE_RAPID);
	virtual	int __fastcall	ExtractMemory(AnsiString Command,void *bf,DWORD &Size,time_t *Time=NULL,WORD *Attr=NULL);
	virtual	int __fastcall	CompressMemory(AnsiString Command,void *bf,DWORD &Size,time_t Time=0,WORD Attr=FA_ARCH);
	virtual	int __fastcall	Check(AnsiString Path);

	__property	TArchiveType	Type={read=FType};
	__property	HMODULE	Handle={read=FHandle};
	__property	bool	Enabled={read=IsEnabled};
	__property	HWND	ParentWindow={read=FParentWindow,write=FParentWindow};
	__property	WORD	Version={read=GetVersion};
	__property	bool	Running={read=GetRunning};
	__property	AnsiString	FileName={read=FFileName,write=SetFileName};
	__property	TArchiveOptions*	Options={read=FOptions,write=FOptions};
	__property	AnsiString	BaseDir={read=FBaseDir,write=FBaseDir};
	__property	DWORD	Mode={read=FMode,write=FMode};
	__property	AnsiString	Output={read=FOutput,write=FOutput};
	__property	INDIVIDUALINFO	*FileInfo={read=GetFileInfo};
	__property	HARC	hArc={read=FhArc,write=FhArc};
	__property	bool	BackGroundMode={read=GetBackGroundMode,write=SetBackGroundMode};
	__property	bool	CursorMode={read=GetCursorMode,write=SetCursorMode};
	__property	WORD	CursorInterval={read=GetCursorInterval,write=SetCursorInterval};
	__property	int		Count={read=GetCount};
};

/*----------------------------------------------*/
/*			TLhaNX							*/
/*----------------------------------------------*/

class	TLha:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TLha(TComponent *Owner);
	__fastcall	~TLha(void);
	int __fastcall	Check(AnsiString Path);
};

/*----------------------------------------------*/
/*			TZipNX							*/
/*----------------------------------------------*/

typedef	int (WINAPI* TZipZip)(const HWND hWnd,LPCSTR szCmdLine,LPSTR szOutput,const DWORD dwSize);
typedef	BOOL (WINAPI* TZipQueryEncryption)(void);

class	TZip:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:
	HMODULE		FZip32jHandle;						//Zip32j DLLnh

	TArcCommand			UnZipUnZip;
	TArcCommand			ZipZip;
	TArcGetVersion		ZipGetVersion;
	TArcGetRunning		ZipGetRunning;
	TArcConfigDialog	ZipConfigDialog;
	TArcSetOwnerWindowEx	ZipSetOwnerWindowEx;
	TZipQueryEncryption		ZipQueryEncryption;

protected:
	void __fastcall	LoadZip32(void);
	bool __fastcall	QueryEncryption(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TZip(TComponent *Owner);
	__fastcall	~TZip(void);
	int __fastcall	Command(AnsiString Cmd);
	int __fastcall	Pack(AnsiString Path);
	int __fastcall	Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr);
	int __fastcall	Unpack(AnsiString Path);
	int __fastcall	Unpack(AnsiString Path,void *bf,DWORD &Size,time_t *Time=NULL,WORD *Attr=NULL);
	int __fastcall	Check(AnsiString Path);
	bool __fastcall	ConfigDialog(int Mode,AnsiString &Option);

	__property	bool	CanEncryption={read=QueryEncryption};
	__property	HMODULE	Zip32jHandle={read=FZip32jHandle};
};

/*----------------------------------------------*/
/*			TCabNX							*/
/*----------------------------------------------*/

class	TCab:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TCab(TComponent *Owner);
	__fastcall	~TCab(void);
	int __fastcall	Check(AnsiString Path);
};

/*----------------------------------------------*/
/*			TTarNX							*/
/*----------------------------------------------*/

class	TTar:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TTar(TComponent *Owner);
	__fastcall	~TTar(void);
};

/*----------------------------------------------*/
/*			TRarNX							*/
/*----------------------------------------------*/

class	TRar:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TRar(TComponent *Owner);
	__fastcall	~TRar(void);
	int __fastcall	Pack(AnsiString Path);
	int __fastcall	Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr);
	int __fastcall	Check(AnsiString Path);
};

/*----------------------------------------------*/
/*			TArjNX							*/
/*----------------------------------------------*/

class	TArj:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TArj(TComponent *Owner);
	__fastcall	~TArj(void);
	int __fastcall	Pack(AnsiString Path);
	int __fastcall	Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time,WORD Attr);
	int __fastcall	Check(AnsiString Path);
};

/*----------------------------------------------*/
/*			TBgaNX							*/
/*----------------------------------------------*/

class	TBga:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TBga(TComponent *Owner);
	__fastcall	~TBga(void);
	int __fastcall	Check(AnsiString Path);
};

/*----------------------------------------------*/
/*			TGcaNX							*/
/*----------------------------------------------*/

class	TGca:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TGca(TComponent *Owner);
	__fastcall	~TGca(void);
};

/*----------------------------------------------*/
/*			TYz1NX							*/
/*----------------------------------------------*/

class	TYz1:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	TYz1(TComponent *Owner);
	__fastcall	~TYz1(void);
};

/*----------------------------------------------*/
/*			T7ZipNX							*/
/*----------------------------------------------*/

class	T7Zip:public TCustomArchiver
{
	typedef	TCustomArchiver	inherited;

private:
	bool		FZipMode;								//ZIP[h

protected:
	AnsiString __fastcall	MakeOptions(void);
	AnsiString __fastcall	MakePackCommand(AnsiString Path);
	AnsiString __fastcall	MakeUnpackCommand(AnsiString Path);

public:
	__fastcall	T7Zip(TComponent *Owner);
	__fastcall	~T7Zip(void);
	int __fastcall	Check(AnsiString Path);

	__property	bool	ZipMode={read=FZipMode,write=FZipMode};
};

/*----------------------------------------------*/
/*			TArchiverNX						*/
/*----------------------------------------------*/

typedef bool __fastcall (__closure *TArchiverProgress)(System::TObject* Sender,int Mode,EXTRACTINGINFO *Info);

class	TArchiver:public TComponent
{
private:
	HWND				FHandle;			//EBhEnh
	UINT				WM_ARCEXTRACT;		//EBhEbZ[W
	TCustomArchiver*	FArchiver;			//A[JCo[
	TArchiveOptions*	FOptions;			//IvV
	HWND				FParentWindow;		//eEBhEnh
	AnsiString			FFileName;			//ɖ
	AnsiString			FBaseDir;			//fBNg
	DWORD				FMode;				//Openɓn[h
	bool				FAborted;			//~tO
	TCriticalSection*	FLock;				//NeBJZNV
	int					FLockCount;			//bNJE^[
	TArchiveType		FZipArchiver;		//ZIPA[JCo[

	TArchiverProgress	FOnProgress;		//R[obN֐

protected:
	void	__fastcall	Init(void);
	void __fastcall	WndProc(Messages::TMessage &Msg);
	void __fastcall	SetFileName(AnsiString FileName);
	TArchiveType __fastcall	GetArchiveType(void);
	void __fastcall	SetArchiveType(TArchiveType Type);
	bool __fastcall	IsEnabled(void);
	bool __fastcall	GetRunning(void);
	INDIVIDUALINFO* __fastcall	GetFileInfo(void);
	void __fastcall	SetParentWindow(HWND hWnd);
	void __fastcall	SetMode(DWORD mode);
	AnsiString __fastcall	GetOutput(void);
	void __fastcall	SetBaseDir(AnsiString Dir);
	AnsiString __fastcall	CorrectPath(AnsiString Path);

public:
	__fastcall	TArchiver(TComponent *owner);
	__fastcall	TArchiver(TComponent *owner,AnsiString FileName);
	__fastcall	~TArchiver(void);
	bool	CallBack(UINT Msg,UINT State,void *Info);
	int __fastcall	Lock(void);
	int __fastcall	Unlock(void);
	TArchiveType __fastcall	GetArchiveTypeFromExt(AnsiString FileName);
	TArchiveType  __fastcall	IsArchive(AnsiString FileName);
	bool __fastcall	IsArchive(void);
	void __fastcall	Unload(void);
	bool __fastcall	Open(DWORD mode=-1);
	void __fastcall	Close(void);
	int __fastcall	Command(AnsiString Cmd);
	void __fastcall	Research(AnsiString Filter);
	bool __fastcall	Find(void);
	int __fastcall	Pack(AnsiString Path);
	int __fastcall	Pack(AnsiString Path,void *bf,DWORD &Size,time_t Time=0,WORD Attr=FA_ARCH);
	int __fastcall	Unpack(AnsiString Path);
	int __fastcall	Unpack(AnsiString Path,void *bf,DWORD &Size,time_t *Time=NULL,WORD *Attr=NULL);
	int __fastcall	Check(AnsiString Path);
	TStringList* __fastcall	GetFileList(TStringList *SList);

	__property	TCustomArchiver*	Archiver={read=FArchiver,write=FArchiver};
	__property	TArchiveType	Type={read=GetArchiveType,write=SetArchiveType};
	__property	bool	Enabled={read=IsEnabled};
	__property	HWND	ParentWindow={read=FParentWindow,write=SetParentWindow};
	__property	bool	Running={read=GetRunning};
	__property	AnsiString	FileName={read=FFileName,write=SetFileName};
	__property	AnsiString	BaseDir={read=FBaseDir,write=SetBaseDir};
	__property	TArchiveOptions*	Options={read=FOptions};
	__property	DWORD	Mode={read=FMode,write=SetMode};
	__property	INDIVIDUALINFO	*FileInfo={read=GetFileInfo};
	__property	AnsiString	Output={read=GetOutput};
	__property	HWND	Handle={read=FHandle};
	__property	bool	Aborted={read=FAborted,write=FAborted};
	__property	int		LockCount={read=FLockCount};
	__property	TArchiveType	ZipArchiver={read=FZipArchiver,write=FZipArchiver};		//ZIPA[JCo[
	__property	TArchiverProgress	OnProgress={read=FOnProgress,write=FOnProgress};

};

}							//namespace Archiver
using namespace ArchiverN;

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

void __fastcall	ArchiverErrorDlg(AnsiString S,int err);

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern	char	*ArchiverErrorMsg[];


#endif

/*****	End	*****/

