/*	Filename:ArcConv.cpp						*/
/************************************************/
/*												*/
/*				A[JCuRo[^			*/
/*												*/
/*					Ver.1.xx   					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 2002-2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <FileCtrl.hpp>
#include <shellapi.h>
#pragma hdrstop

#include "main.h"
#include "FindFile.h"
#include "WaitCursor.h"
#include "DSDEF.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TFormArcConv *FormArcConv;

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	URLJ	*****/

bool __fastcall	OpenURL(AnsiString URL)
{
	if ((int)::ShellExecute(NULL,"opennew",URL.c_str(),NULL,NULL,SW_SHOW)>32)
	then	return(true);

	if ((int)::ShellExecute(NULL,"open",URL.c_str(),NULL,NULL,SW_SHOW)>32)
	then	return(true);

	return(false);
}

/*****	t@C^fBNg̃f[g	*****/

bool __fastcall	DeleteFiles(AnsiString Path)
{
	bool	Res=true;

	TFindFile	Find;
	Find.Mask=faVolumeID;
	Find.Research(Path);
	while(Find.Find())
	{
		if (Find.FileAtr & faVolumeID)
		then	continue;

		if (Find.FileAtr & faReadOnly)
		then {
			FileSetAttr(Find.Path,Find.FileAtr & (~faReadOnly));
		}
		if (Find.FileAtr & faDirectory)
		then {
			Path=Find.Path;
			if (*(Path.AnsiLastChar()) != '\\')
			then	Path+="\\*.*";
			else	Path+="*.*";
			if (DeleteFiles(Path)==false)
			then	Res=false;
			if (RemoveDir(Find.Path)==false)
			then	Res=false;
		}
		else {
			if (DeleteFile(Find.Path)==false)
			then	Res=false;
		}
	}

	return(Res);
}

/*----------------------------------------------*/
/*				TFormArcConvNX				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall TFormArcConv::TFormArcConv(TComponent* Owner)
	: TForm(Owner)
{
	FArchiver=new TArchiver(this);
	FArchiver->OnProgress=OnProgress;
}

/*****	EBhE쐬p[^̐ݒ	*****/

void __fastcall TFormArcConv::CreateParams(Controls::TCreateParams &Params)
{
	inherited::CreateParams(Params);				//e(TForm)CreateParamsĂŃp[^쐬

	Params.ExStyle |=WS_EX_ACCEPTFILES;				//hbvt@C󂯕t悤ɂ
}

/*****	EBhEN[Y	*****/

void __fastcall TFormArcConv::FormClose(TObject *Sender,
	  TCloseAction &Action)
{
	delete	FArchiver;
	FArchiver=NULL;

	AnsiString	S=ExtractFileDir(Application->ExeName);
	S+="\\Temp";
	DeleteFiles(S);
}

/*****	t@Chbvꂽ	*****/

#pragma warn -aus

void __fastcall TFormArcConv::WMDropFiles(TWMDropFiles& Msg)
{
	int			DropCount=::DragQueryFile((void*)(Msg.Drop),0xFFFFFFFF,NULL,0);	//hbvꂽt@C̐
	char		*bf=new char[MAX_PATH+16];										//t@C擾pobt@
	int			i;

	::DragQueryFile((void*)(Msg.Drop),0,bf,MAX_PATH+16);		//t@C擾
	SetArchive(bf);


	::DragFinish((void*)(Msg.Drop));					//D&DIʒm
	delete	bf;

	Msg.Result=0;										//bZ[W
}

#pragma warn .aus

/*****	ɂ̐ݒ	*****/

void __fastcall	TFormArcConv::SetArchive(AnsiString FileName)
{
	AnsiString	S;

	LabelSource->Caption=FileName;
	LabelSource->Hint=LabelSource->Caption;

	FArchiver->FileName=FileName;
	FArchiver->Research("*.*");
	Memo->Clear();
	while(FArchiver->Find())
	{
		S=Format("%s %u",OPENARRAY(TVarRec,((FArchiver->FileInfo->szFileName),((int)FArchiver->FileInfo->dwOriginalSize))));
		Memo->Lines->Add(S);
	}
    FArchiver->Close();

	ComboBoxDestChange(this);

	ButtonUnpack->Enabled=true;
}

/*****	ϊ揑ɂ̕ύX	*****/

void __fastcall TFormArcConv::ComboBoxDestChange(TObject *Sender)
{
	char	*ext[]={".lzh",".zip",".cab",".tar",".gz",".bz2",".gza",".bza",".gca",".yz1"};
	AnsiString	S;

	if (ComboBoxDest->ItemIndex<0)
	then	ComboBoxDest->ItemIndex=0;

	LabelDest->Caption=ChangeFileExt(LabelSource->Caption,ext[ComboBoxDest->ItemIndex]);
	LabelDest->Hint=LabelDest->Caption;
	if (AnsiLowerCase(ExtractFileExt(LabelSource->Caption))==AnsiLowerCase(ExtractFileExt(LabelDest->Caption)))
	then	ButtonConvert->Enabled=false;
	else	ButtonConvert->Enabled=true;
}

/*****		*****/

int __fastcall TFormArcConv::Unpack(void)
{
	TWaitCursor	csr;
	AnsiString		S;

	S=ExtractFileDir(Application->ExeName);
	S+="\\Temp\\*.*";
	DeleteFiles(S);
	S=ExtractFileDir(S);
	Application->ProcessMessages();
	if (ForceDirectories(S)==false)
	then {
		Memo->Lines->Add("fBNg쐬s");
		return(-1);
	}
	while(DirectoryExists(S)==false) 		//mɍ쐬܂ő҂
	{
		Application->ProcessMessages();
	}

	FArchiver->FileName=LabelSource->Caption;
	FArchiver->BaseDir=S;
	int	res=FArchiver->Unpack("");

	S="Unpack=";
	S+=IntToHex(res,1);
	Memo->Lines->Add(S);

	ProgressBar->Position=0;

	return(res);
}

/*****		*****/

void __fastcall TFormArcConv::ButtonUnpackClick(TObject *Sender)
{
	Unpack();
}

/*****	ϊ	*****/

void __fastcall TFormArcConv::ButtonConvertClick(TObject *Sender)
{
	if (Unpack() != 0)
	then	return;

	TWaitCursor	csr;

	FArchiver->FileName=LabelDest->Caption;
	if (FileExists(FArchiver->FileName))
	then {
		if (DeleteFile(FArchiver->FileName))
		then {
			while(FileExists(FArchiver->FileName))		//m폜܂ő҂
			{
				Application->ProcessMessages();
			}
		}
	}
	AnsiString	ext=AnsiLowerCase(ExtractFileExt(FArchiver->FileName));
	if (ext==".gz")
	then	FArchiver->Options->Method="z";
	if (ext==".bz2")
	then	FArchiver->Options->Method="B";

	int	res=FArchiver->Pack("*.*");

	AnsiString	S="Pack=";
	S+=IntToHex(res,1);
	Memo->Lines->Add(S);

	FArchiver->Options->UserOption="";
}

/*****	vOXCxg	*****/

bool __fastcall	TFormArcConv::OnProgress(TObject *Sender,int Mode,EXTRACTINGINFO *Info)
{
	double	n=0;

	if ((Info) AND (Info->dwFileSize))
	then	n=(double)Info->dwWriteSize/Info->dwFileSize;

	ProgressBar->Position=n*100;

	return(true);
}

/*****	wv	*****/

void __fastcall TFormArcConv::ButtonHelpClick(TObject *Sender)
{
	AnsiString	S=ExtractFileDir(Application->ExeName);
	SetCurrentDir(S);
	S="TArchiver.chm";
	if (FileExists(S)==false)
	then	S="..\\..\\"+S;

	OpenURL(S);
}

/****	End	*****/

